/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfilecontent
#define headerfilecontent

#include <cstdlib>
#include <fcgiapp.h>

#include "../templates/templates.h"
#include "../core/request.h"
#include "../core/error.h"
#include "../core/misc.h"
#include "../core/db.h"
#include "../core/user.h"
#include "../core/function.h"
#include "../core/functionparser.h"



class Content
{
	Templates templates;



	
	void PrepareUrl(Item & item);
	
	
	void SetDefaultFunction();
	bool DirsHaveReadExecPerm();

	void MakeStandardFunction();
	
	
	
	void MakePost();
	
	void FunCat();
	void FunLogout();
	void FunLs();
	void FunEmacs();
	void FunPriv();
	void FunRm();
	void FunNode();
	void FunMkdir();
	void FunDefault();
	void FunRun();
	
	
	void PostFunLogin();
	void PostFunEmacsAdd();
	void PostFunEmacsEdit(bool with_url);
	void PostFunEmacs();
	void PostFunMkdir();
	void PostFunDefault();
	void PostFunPriv();

	void RedirectTo(const Item & item);
	void RedirectTo(long item_id);
	
public:

	bool Init();
	
	void Make();
	

};


#endif
